--- origsrc/screen-4.6.2/socket.c	2017-10-23 20:32:41.000000000 +0900
+++ src/screen-4.6.2/socket.c	2019-03-08 23:31:11.373592400 +0900
@@ -537,6 +537,9 @@
   xseteuid(real_uid);
   xsetegid(real_gid);
 # endif
+#ifdef __CYGWIN__
+  setsockopt(s, SOL_SOCKET, SO_PEERCRED, NULL, 0);
+#endif
   if (connect(s, (struct sockaddr *) &a, strlen(SockPath) + 2) != -1)
     {
       debug("oooooh! socket already is alive!\n");
@@ -628,6 +631,9 @@
       return -1;
     }
 #endif
+#ifdef __CYGWIN__
+  setsockopt(s, SOL_SOCKET, SO_PEERCRED, NULL, 0);
+#endif
   if (connect(s, (struct sockaddr *)&a, strlen(SockPath) + 2) == -1)
     {
       if (err)
@@ -1058,6 +1064,9 @@
     {
       len = sizeof(a);
       debug("Ha, there was someone knocking on my socket??\n");
+#ifdef __CYGWIN__
+      setsockopt(ns, SOL_SOCKET, SO_PEERCRED, NULL, 0);
+#endif
       if ((ns = accept(ns, (struct sockaddr *)&a, (void *)&len)) < 0)
         {
           Msg(errno, "accept");
@@ -1308,6 +1317,9 @@
     }
   else
     {
+#ifdef __CYGWIN__
+      setsockopt(s, SOL_SOCKET, SO_PEERCRED, NULL, 0);
+#endif
       len = sizeof(a);
       s = accept(s, (struct sockaddr *)&a, (void *)&len);
       if (s < 0)
@@ -1343,6 +1355,9 @@
   if (stat(sap->sun_path, &st))
     return -1;
   chmod(sap->sun_path, 0);
+#ifdef __CYGWIN__
+  setsockopt(s, SOL_SOCKET, SO_PEERCRED, NULL, 0);
+#endif
   x = connect(s, (struct sockaddr *) sap, len);
   chmod(sap->sun_path, st.st_mode);
   return x;
